## Description
The AWS support portal allows account owners to establish security questions that can be used to authenticate individuals calling AWS customer service for support. It is recommended that security questions be established.

## Rationale Statement
When creating a new AWS account, a default super user is automatically created. This account is referred to as the "root user" account. It is recommended that the use of this account be limited and highly controlled. During events in which the Root password is no longer accessible or the MFA token associated with root is lost/destroyed it is possible, through authentication using secret questions and associated answers, to recover root user login access.

## Remediation Procedure
From Console:

1. Login to the AWS Account as the root user
1. Click on the <Root_Account_Name> from the top right of the console
1. From the drop-down menu Click My Account
1. Scroll down to the Configure Security Questions section
1. Click on Edit
1. Click on each Question
1. From the drop-down select an appropriate question
1. Click on the Answer section
1. Enter an appropriate answer
1. Follow process for all 3 questions
1. Click Update when complete
1. Place Questions and Answers and place in a secure physical location
